// #autoload
// #name = HuntersHUD
// #category = Cowboy
// #version = 1.0
// #description = Lots more cool info displayed in the "Objective Hud" for Team Hunters.
// #date = July 8, 2001
// #author = "Cowboy" Ben Alman
// #warrior = Cowboy
// #email = cowboy@CowboyScripts.org
// #web = http://CowboyScripts.org/
// #credit = I'm told the file I modified was originally written by Ptavv. If so, good job man, cool idea!
// #readme = scripts/autoexec/HuntersHUD_readme.txt
// #status = release
// ---------------------------------------------------------------------------

echo("---------------------");
echo("   HuntersHUD v1.0   ");
echo("by Cowboy++, 7/8/2001");
echo("---------------------");


package HuntersHUD {

function setupObjHud(%gameType)
{
	$HuntersHUD::Type = %gametype;
	
	parent::setupObjHud(%gametype);
	switch$ (%gameType)
	{
		case HuntersGame:
			objectiveHud.setSeparators("96 132 209");
			objectiveHud.disableHorzSeparator();
			// worth label ("WORTH")
			objectiveHud.worthLabel = new GuiTextCtrl() {
				profile = "GuiTextObjGreenLeftProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "138 19";
				extent = "70 16";
				visible = "1";
				text = "WORTH";
			};
			// worth of flags
			objectiveHud.worthValue = new GuiTextCtrl() {
				profile = "GuiTextObjGreenCenterProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "212 19";
				extent = "30 16";
				visible = "1";
			};
			objectiveHud.add(objectiveHud.worthLabel);
			objectiveHud.add(objectiveHud.worthValue);

		case TeamHuntersGame:
			objectiveHud.setSeparators("43 87 88 89 161 203 204 205");

			// "WORTH" label
			objectiveHud.worthLabel = new GuiTextCtrl() {
				profile = "GuiTextObjGreenLeftProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "4 19";
				extent = "38 16";
				visible = "1";
				text = "WORTH";
			};
			// worth of flags
			objectiveHud.worthValue = new GuiTextCtrl() {
				profile = "GuiTextObjGreenCenterProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "44 19";
				extent = "44 16";
				visible = "1";
			};

			// "NEED" label
			objectiveHud.flagsNeededLabel = new GuiTextCtrl() {
				profile = "GuiTextObjGreenCenterProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "209 3";
				extent = "32 16";
				visible = "1";
				text = "NEED";
			};

			// Flags the losing team needs to cap - to tie or beat
			objectiveHud.flagsNeededValue = new GuiTextCtrl() {
				profile = "HuntersHUDgreen";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "209 19";
				extent = "32 16";
				visible = "1";
			};
			
			objectiveHud.flagLabel.position = "4 3";
			objectiveHud.flagLabel.extent = "38 16";
			
			objectiveHud.yourFlags.position = "44 3";
			objectiveHud.yourFlags.extent = "44 16";

			objectiveHud.teamName[1].position = "94 3";
			objectiveHud.teamName[1].extent = "62 16";

			objectiveHud.teamName[2].position = "94 19";
			objectiveHud.teamName[2].extent = "62 16";

			objectiveHud.teamScore[1].position = "163 3";
			objectiveHud.teamScore[2].position = "163 19";
			
			objectiveHud.add(objectiveHud.worthLabel);
			objectiveHud.add(objectiveHud.worthValue);
			objectiveHud.add(objectiveHud.flagsNeededLabel);
			objectiveHud.add(objectiveHud.flagsNeededValue);
			
			$HuntersHUD::flags = 0;
			$HuntersHUD::score[1] = 0;
			$HuntersHUD::score[2] = 0;
			
			objectiveHud.flagsNeededValue.setValue(0);
	}
}

function huntYouHaveFlags(%msgType, %msgString, %a1, %a2, %a3, %a4, %a5, %a6) {
	parent::huntYouHaveFlags(%msgType, %msgString, %a1, %a2, %a3, %a4, %a5, %a6);
	
	$HuntersHUD::yourFlags = detag(%a1);

	objectiveHud.worthValue.setValue(flagsToScore($HuntersHUD::yourFlags));

	UpdateTeamHunters();
}

function teamScoreIs(%msgType, %msgString, %a1, %a2, %a3, %a4, %a5, %a6) {
	parent::teamScoreIs(%msgType, %msgString, %a1, %a2, %a3, %a4, %a5, %a6);

	%teamNum = detag(%a1);
	%score = detag(%a2);

	if(%score $= "")
		%score = 0;

	$HuntersHUD::score[%teamNum] = %score;

	UpdateTeamHunters();
}

};
activatePackage(HuntersHUD);

addMessageCallback('MsgCheckTeamLines', UpdateTeamHunters);

addMessageCallback('MsgClientJoinTeam', youChangedTeams);

function youChangedTeams(%msgType, %msgString, %clientName, %teamName, %clientId, %teamId) {
	if(strpos(%msgString, "You joined the") != -1)
		UpdateTeamHunters();
}

function UpdateTeamHunters() {

	if ($HuntersHUD::Type $= "TeamHuntersGame") {
		%t1 = $HuntersHUD::score[1];
		%t2 = $HuntersHUD::score[2];
		
		%diff = %t1 - %t2;
		%isneg = %diff == 0 ? 1 : %diff / abs(%diff);         
		%isteam = %isneg == 1 ? 1 : 2;                        
		%toTie = flagsNeededToTie(abs(%diff));
		
		if (%isteam == getClientTeamId(getManagerId())) {
			objectiveHud.flagsNeededLabel.profile = "HuntersHUDwhite";
			objectiveHud.flagsNeededValue.profile = "HuntersHUDwhite";
	
			objectiveHud.flagLabel.profile = "HuntersHUDwhite";
			objectiveHud.yourFlags.profile = "HuntersHUDwhite";
			objectiveHud.worthLabel.profile = "HuntersHUDwhite";
			objectiveHud.worthValue.profile = "HuntersHUDwhite";
		}
		else if ($HuntersHUD::yourFlags >= %toTie) {
			objectiveHud.flagsNeededLabel.profile = "HuntersHUDgreen";
			objectiveHud.flagsNeededValue.profile = "HuntersHUDgreen";
	
			objectiveHud.flagLabel.profile = "HuntersHUDgreen";
			objectiveHud.yourFlags.profile = "HuntersHUDgreen";
			objectiveHud.worthLabel.profile = "HuntersHUDgreen";
			objectiveHud.worthValue.profile = "HuntersHUDgreen";
		}
		else {
			objectiveHud.flagsNeededLabel.profile = "HuntersHUDyellow";
			objectiveHud.flagsNeededValue.profile = "HuntersHUDyellow";
	
			objectiveHud.flagLabel.profile = "HuntersHUDyellow";
			objectiveHud.yourFlags.profile = "HuntersHUDyellow";
			objectiveHud.worthLabel.profile = "HuntersHUDyellow";
			objectiveHud.worthValue.profile = "HuntersHUDyellow";
		}
		
		objectiveHud.flagsNeededValue.setValue(%toTie);
	}
}


function flagsToScore(%flags) {
	return ((%flags + 1) * %flags / 2);
}

function scoreToFlags(%score) {
	return mFloor(mSqrt(%score * 2));
}

function flagsNeededToTie(%score) {
	%flags = scoreToFlags(%score);
	if (flagsToScore(%flags) < %score)
		%flags++;

	return %flags;
}


new GuiControlProfile ("HuntersHUDwhite")
{
	fontType = "Univers Condensed";
	fontSize = 16;
	fontColor = "169 215 250";
   fontColors[6] = $PlayerNameColor;
   fontColors[7] = $TribeTagColor;  
   fontColors[8] = $SmurfNameColor; 
   fontColors[9] = $BotNameColor;   
	justify = "center";
};

new GuiControlProfile ("HuntersHUDgreen")
{
	fontType = "Univers Condensed";
	fontSize = 16;
	fontColor = "23 236 67";
   fontColors[6] = $PlayerNameColor;
   fontColors[7] = $TribeTagColor;  
   fontColors[8] = $SmurfNameColor; 
   fontColors[9] = $BotNameColor;   
	justify = "center";
};

new GuiControlProfile ("HuntersHUDyellow")
{
	fontType = "Univers Condensed";
	fontSize = 16;
	fontColor = "255 205 0";
   fontColors[6] = $PlayerNameColor;
   fontColors[7] = $TribeTagColor;  
   fontColors[8] = $SmurfNameColor; 
   fontColors[9] = $BotNameColor;   
	justify = "center";
};


